#!/usr/bin/gnuplot

# normalized turnaround time

reset

set terminal postscript enhanced eps color font 'Times-New-Roman' 28

set tmargin 2
set bmargin 6
set lmargin 8
set rmargin 4

set output 'ntt.eps'

set size 2.8,1

set boxwidth 1 absolute
set style histogram errorbars gap 2 lw 1
set style data histogram
set style fill solid 1.00 border 0
set key spacing 0.8 samplen 2
set key font 'Times,32' outside top center maxrows 1 width -4 spacing 1 samplen 2
set grid ytics mytics
set grid
set xtics rotate by -45
set datafile separator ','
set grid ytics
set ylabel 'NTT'
set yrange [0:1.6]

set datafile separator ','

plot 'ntt.csv' using 2:3:xtic(1) t 'Batch' lt 1 lc rgb 'white', \
     '' using 4:5:xtic(1) t 'Native' lt 1 lc rgb 'black', \
     '' using 6:7:xtic(1) t 'Equal Partition' lt 1 fillstyle pattern 5, \
     '' using 8:9:xtic(1) t 'Scalability Based' lt 1 lc rgb 'red', \
     '' using 10:11:xtic(1) t 'NuPoco Greedy' lt 1 lc rgb 'green', \
     '' using 12:13:xtic(1) t 'NuPoco' lt 1 lc rgb 'blue'
unset output

# absolute turnaround time

reset

set terminal postscript enhanced eps color font 'Times-New-Roman' 28

set tmargin 2
set bmargin 6
set lmargin 8
set rmargin 4

set output 'ttt.eps'

set size 2.8,1

set boxwidth 1 absolute
set style histogram errorbars gap 2 lw 1
set style data histogram
set style fill solid 1.00 border 0
set key spacing 0.8 samplen 2
set key font 'Times,32' outside top center maxrows 1 width -4 spacing 1 samplen 2
set grid ytics mytics
set grid
set xtics rotate by -45
set datafile separator ','
set grid ytics
set ylabel 'Absolute TT'
set yrange [0:200]

set datafile separator ','

plot 'ttt.csv' using 2:3:xtic(1) t 'Batch' lt 1 lc rgb 'white', \
     '' using 4:5:xtic(1) t 'Native' lt 1 lc rgb 'black', \
     '' using 6:7:xtic(1) t 'Equal Partition' lt 1 fillstyle pattern 5, \
     '' using 8:9:xtic(1) t 'Scalability Based' lt 1 lc rgb 'red', \
     '' using 10:11:xtic(1) t 'NuPoco Greedy' lt 1 lc rgb 'green', \
     '' using 12:13:xtic(1) t 'NuPoco' lt 1 lc rgb 'blue'
unset output

# average turnaround time

reset

set terminal postscript enhanced eps color font 'Times-New-Roman' 28

set tmargin 2
set bmargin 6
set lmargin 8
set rmargin 4

set output 'avg.eps'

set size 2.8,1

set boxwidth 1 absolute
set style histogram errorbars gap 2 lw 1
set style data histogram
set style fill solid 1.00 border 0
set key spacing 0.8 samplen 2
set key font 'Times,32' outside top center maxrows 1 width -4 spacing 1 samplen 2
set grid ytics mytics
set grid
set xtics rotate by -45
set datafile separator ','
set grid ytics
set ylabel 'Absolute TT'
set yrange [0:200]

set datafile separator ','

plot 'avg.csv' using 2:3:xtic(1) t 'Native' lt 1 lc rgb 'black', \
     '' using 4:5:xtic(1) t 'Equal Partition' lt 1 fillstyle pattern 5, \
     '' using 6:7:xtic(1) t 'Scalability Based' lt 1 lc rgb 'red', \
     '' using 8:9:xtic(1) t 'NuPoco Greedy' lt 1 lc rgb 'green', \
     '' using 10:11:xtic(1) t 'NuPoco' lt 1 lc rgb 'blue'
unset output

