#!/usr/bin/env python

import commands, subprocess, re, time, sys, csv
import datetime
from os.path import exists
import os
import itertools

scheduler = os.environ["SCHEDULER_OPTION"]

log_dir = "log/standalone/"

apps = ["bt", "ep", "ft", "sp", "km"]

binary = {"bt":"../applications/bin/bt.D.x",\
          "ep":"../applications/bin/ep.D.x",\
          "ft":"../applications/bin/ft.D.x",\
          "sp":"../applications/bin/sp.D.x",\
          "km":"../applications/kmeans/bin/kmeans"}

args = {"bt":" ",\
        "ep":" ",\
        "ft":" ",\
        "sp":" ",\
        "km":" -i ../applications/kmeans/data/inputGen/3000000_34.txt"}

def run_benchmark(app, scheduler, logname):
    log = open(log_dir + logname + ".log", "w+")
    print logname

    command_prefix = ""

    start_time = datetime.datetime.now()

    command = command_prefix+" "+binary[app]+" "+args[app]
    output = commands.getoutput(command)

    turnaround_time = (datetime.datetime.now()-start_time).total_seconds()

    output_log = open(log_dir+"output/"+logname+".output.log", "w+")
    output_log.write(output)
    output_log.close()

    turnaround_time_log = "Turnaround time: "+str(turnaround_time)+"\n"

    log.write(turnaround_time_log)
    log.close()

    return

if not exists(log_dir):
    os.system("mkdir -p "+log_dir)
    os.system("mkdir -p "+log_dir+"/output")

for iteration in ["1","2","3"]:
    for app in apps:
        logname = app+"."+scheduler+"."+iteration
        if exists(log_dir + logname + ".log"):
            print logname + ".log" + " is already exists"
        else:
            time.sleep(3)
            run_benchmark(app, scheduler, logname)

