//------------------------------------------------------------------------------
/// @brief RTE common header
/// @author Younghyun Cho <younghyun@csap.snu.ac.kr>
/// Computer Systems and Platforms Laboratory
/// Department of Computer Science and Engineering
/// Seoul National University
///
/// @section license_section Licence
/// Copyright (c) 2016 Computer Systems and Platforms Laboratory
/// All rights reserved.
/// 
/// @decription common.h
/// Dynamic RTE common description header
///
//------------------------------------------------------------------------------

#ifndef __RTE_COMMON_H_
#define __RTE_COMMON_H_

/// @brief define the architecture-specific data types and data units
///
/// @description currently we support three different platforms
#if defined(__i386__)
#define BERN
#elif defined(__x86_64__)
#define AMD64
#elif defined(__tile__)
#define TILERA
#else
#error Dynamic RTE does not support this platform
#endif

/// @brief turn on/off RTE options
///
/// @description 1: turn on the option, 0: turn off the option
#define APP_PROFILES         0 ///< dump application performance profiles

#ifndef DEBUG_MODE
#   define DEBUG_MODE        0 ///< show debug and log message
#endif

#endif // __RTE_COMMON_H_

